/*
An Arduino code example for interfacing with the HMC5883

by: Jordan McConnell
 SparkFun Electronics
 created on: 6/30/11
 license: OSHW 1.0, http://freedomdefined.org/OSHW

Analog input 4 I2C SDA
Analog input 5 I2C SCL
*/

#include <Wire.h> //I2C Arduino Library
#include <Servo.h>


#define address 0x1E //0011110b, I2C 7bit address of HMC5883

Servo myservo;  // create servo object to control a servo

void setup(){
  //Initialize Serial and I2C communications
  Serial.begin(9600);
  Wire.begin();
  
  //Put the HMC5883 IC into the correct operating mode
  Wire.beginTransmission(address); //open communication with HMC5883
  Wire.write(0x02); //select mode register
  Wire.write(0x00); //continuous measurement mode
  Wire.endTransmission();
  
  myservo.attach(9);  // attaches the servo on pin 9 to the servo object
}

void loop(){
  
  int x1,y1,z1; //triple axis data
  int val; 
  
  //Tell the HMC5883 where to begin reading data
  Wire.beginTransmission(address);
  Wire.write(0x03); //select register 3, X MSB register
  Wire.endTransmission();
  
 
 
 //Read data from each axis, 2 registers per axis
  Wire.requestFrom(address, 6);
  if(6<=Wire.available()){
    x1 = Wire.read()<<8; //X msb
    x1 |= Wire.read(); //X lsb
    z1 = Wire.read()<<8; //Z msb
    z1 |= Wire.read(); //Z lsb
    y1 = Wire.read()<<8; //Y msb
    y1 |= Wire.read(); //Y lsb
  }
  
  //Print out values of each axis
  Serial.print("x: ");
  Serial.print(x1);
  Serial.print("  y: ");
  Serial.print(y1);
  Serial.print("  z: ");
  Serial.println(z1);

//This block was testing to see if the magnetometer could move the servo. It can. Lower limit is 10 because servo makes horrible noises below that.
//  val = x;
//  val = map(val, -1000, 500, 10, 180);  // scale it to use it with the servo (value between 10 and 180) 
//  myservo.write(val); 

delay(2000);

//The x & y vals below are based on the normal range when I was experimenting. Later I'd want to have normal ranges as variables that setup() finds.

  if((x1>475) || (x1<335) || (y1<-580)||(y1>-480)){
  Serial.println("Cat detected");      
  }

//This block was testing to see if resetting the values to 0 would fix it
//  x1 = 0;
//  y1 = 0;
//  z1 = 0;
}
